export { loadTelefuncFilesWithImportBuild };
export { setTelefuncLoaders };
import { config } from '../../../server/serverConfig.js';
import { getGlobalObject } from '../../utils.js';
import { assertManifest } from './assertManifest.js';
const globalObject = getGlobalObject('loadBuild.ts', {});
function setTelefuncLoaders({ loadTelefuncFiles, loadManifest, }) {
    globalObject.loadTelefuncFiles = loadTelefuncFiles;
    setServerConfig(loadManifest);
}
function setServerConfig(loadManifest) {
    const manifest = loadManifest();
    assertManifest(manifest);
    Object.assign(config, manifest.config);
}
async function loadTelefuncFilesWithImportBuild() {
    if (!globalObject.loadTelefuncFiles) {
        return null;
    }
    const moduleExports = await globalObject.loadTelefuncFiles();
    return moduleExports;
}
